import { ObfuscatorOptions } from "javascript-obfuscator";
type OmitKeys<T, U extends string> = T & {
    [key in U]: never;
};
export type NextjsObfuscatorOptions = OmitKeys<ObfuscatorOptions, "inputFileName" | "sourceMapBaseUrl" | "sourceMapFileName" | "sourceMapMode" | "sourceMapSourcesMode">;
export declare const LoggerSymbol: unique symbol;
export type InternalNextjsObfuscatorOptions = NextjsObfuscatorOptions & {
    [LoggerSymbol]: (...messages: any[]) => void;
};
export {};
